#define WINNT
#define _WIN32_WINNT 0x501
#define ID_TIMER 800

#include "resource.h"
#include <windows.h>
#include <commctrl.h>
#include <psapi.h>
#include <strsafe.h>

HWND hwndCap;

HWND SetCurrentTab(HWND hwnd, int tab);
int ShutdownWindows(UINT type, HWND parentHwnd);

INT_PTR CALLBACK AboutDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
switch(uMsg) {
	case WM_INITDIALOG:
	break;
	case WM_COMMAND:
	switch(LOWORD(wParam)) {
		case IDOK:
		EndDialog(hwndDlg, IDOK);
		break;
	}
	break;
	case WM_CLOSE:
	EndDialog(hwndDlg, 0);
	break;
	default:
	return false;
}
return true;
}

INT_PTR CALLBACK ExWinStyleDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
switch(uMsg) {
	case WM_INITDIALOG:
	{
	unsigned int exStyle = GetWindowLong(hwndCap, GWL_EXSTYLE);
	
	if ((exStyle & WS_EX_DLGMODALFRAME) == WS_EX_DLGMODALFRAME)
		SendDlgItemMessage(hwndDlg, IDB_EX_DLGMODALFRAME, BM_SETCHECK, BST_CHECKED, 0);
	if ((exStyle & WS_EX_NOPARENTNOTIFY) == WS_EX_NOPARENTNOTIFY)
		SendDlgItemMessage(hwndDlg, IDB_EX_NOPARENTNOTIFY, BM_SETCHECK, BST_CHECKED, 0);
	if ((exStyle & WS_EX_TOPMOST) == WS_EX_TOPMOST)
		SendDlgItemMessage(hwndDlg, IDB_EX_TOPMOST, BM_SETCHECK, BST_CHECKED, 0);
	if ((exStyle & WS_EX_ACCEPTFILES) == WS_EX_ACCEPTFILES)
		SendDlgItemMessage(hwndDlg, IDB_EX_ACCEPTFILES, BM_SETCHECK, BST_CHECKED, 0);
	if ((exStyle & WS_EX_TRANSPARENT) == WS_EX_TRANSPARENT)
		SendDlgItemMessage(hwndDlg, IDB_EX_TRANSPARENT, BM_SETCHECK, BST_CHECKED, 0);
	if ((exStyle & WS_EX_MDICHILD) == WS_EX_MDICHILD)
		SendDlgItemMessage(hwndDlg, IDB_EX_MDICHILD, BM_SETCHECK, BST_CHECKED, 0);
	if ((exStyle & WS_EX_TOOLWINDOW) == WS_EX_TOOLWINDOW)
		SendDlgItemMessage(hwndDlg, IDB_EX_TOOLWINDOW, BM_SETCHECK, BST_CHECKED, 0);
	if ((exStyle & WS_EX_WINDOWEDGE) == WS_EX_WINDOWEDGE)
		SendDlgItemMessage(hwndDlg, IDB_EX_WINDOWEDGE, BM_SETCHECK, BST_CHECKED, 0);
	if ((exStyle & WS_EX_CLIENTEDGE) == WS_EX_CLIENTEDGE)
		SendDlgItemMessage(hwndDlg, IDB_EX_CLIENTEDGE, BM_SETCHECK, BST_CHECKED, 0);
	if ((exStyle & WS_EX_CONTEXTHELP) == WS_EX_CONTEXTHELP)
		SendDlgItemMessage(hwndDlg, IDB_EX_CONTEXTHELP, BM_SETCHECK, BST_CHECKED, 0);
	if ((exStyle & WS_EX_RIGHT) == WS_EX_RIGHT)
		SendDlgItemMessage(hwndDlg, IDB_EX_RIGHT, BM_SETCHECK, BST_CHECKED, 0);
	if ((exStyle & WS_EX_LEFT) == WS_EX_LEFT)
		SendDlgItemMessage(hwndDlg, IDB_EX_LEFT, BM_SETCHECK, BST_CHECKED, 0);
	if ((exStyle & WS_EX_RTLREADING) == WS_EX_RTLREADING)
		SendDlgItemMessage(hwndDlg, IDB_EX_RTLREADING, BM_SETCHECK, BST_CHECKED, 0);
	if ((exStyle & WS_EX_LTRREADING) == WS_EX_LTRREADING)
		SendDlgItemMessage(hwndDlg, IDB_EX_LTRREADING, BM_SETCHECK, BST_CHECKED, 0);
	if ((exStyle & WS_EX_LEFTSCROLLBAR) == WS_EX_LEFTSCROLLBAR)
		SendDlgItemMessage(hwndDlg, IDB_EX_LEFTSCROLLBAR, BM_SETCHECK, BST_CHECKED, 0);
	if ((exStyle & WS_EX_RIGHTSCROLLBAR) == WS_EX_RIGHTSCROLLBAR)
		SendDlgItemMessage(hwndDlg, IDB_EX_RIGHTSCROLLBAR, BM_SETCHECK, BST_CHECKED, 0);
	if ((exStyle & WS_EX_CONTROLPARENT) == WS_EX_CONTROLPARENT)
		SendDlgItemMessage(hwndDlg, IDB_EX_CONTROLPARENT, BM_SETCHECK, BST_CHECKED, 0);
	if ((exStyle & WS_EX_STATICEDGE) == WS_EX_STATICEDGE)
		SendDlgItemMessage(hwndDlg, IDB_EX_STATICEDGE, BM_SETCHECK, BST_CHECKED, 0);
	if ((exStyle & WS_EX_APPWINDOW) == WS_EX_APPWINDOW)
		SendDlgItemMessage(hwndDlg, IDB_EX_APPWINDOW, BM_SETCHECK, BST_CHECKED, 0);
	if ((exStyle & WS_EX_OVERLAPPEDWINDOW) == WS_EX_OVERLAPPEDWINDOW)
		SendDlgItemMessage(hwndDlg, IDB_EX_OVERLAPPEDWINDOW, BM_SETCHECK, BST_CHECKED, 0);
	if ((exStyle & WS_EX_PALETTEWINDOW) == WS_EX_PALETTEWINDOW)
		SendDlgItemMessage(hwndDlg, IDB_EX_PALETTEWINDOW, BM_SETCHECK, BST_CHECKED, 0);
	if ((exStyle & WS_EX_LAYERED) == WS_EX_LAYERED)
		SendDlgItemMessage(hwndDlg, IDB_EX_LAYERED, BM_SETCHECK, BST_CHECKED, 0);
	if ((exStyle & WS_EX_NOINHERITLAYOUT) == WS_EX_NOINHERITLAYOUT)
		SendDlgItemMessage(hwndDlg, IDB_EX_NOINHERITLAYOUT, BM_SETCHECK, BST_CHECKED, 0);
	if ((exStyle & WS_EX_LAYOUTRTL) == WS_EX_LAYOUTRTL)
		SendDlgItemMessage(hwndDlg, IDB_EX_LAYOUTRTL, BM_SETCHECK, BST_CHECKED, 0);
	if ((exStyle & WS_EX_COMPOSITED) == WS_EX_COMPOSITED)
		SendDlgItemMessage(hwndDlg, IDB_EX_COMPOSITED, BM_SETCHECK, BST_CHECKED, 0);
	if ((exStyle & WS_EX_NOACTIVATE) == WS_EX_NOACTIVATE)
		SendDlgItemMessage(hwndDlg, IDB_EX_NOACTIVATE, BM_SETCHECK, BST_CHECKED, 0);
	}
	break;
	case WM_COMMAND:
	switch(LOWORD(wParam)) {
		case IDOK:
		{
		unsigned int newExStyle = 0;
		
		if (SendDlgItemMessage(hwndDlg, IDB_EX_DLGMODALFRAME, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newExStyle |= WS_EX_DLGMODALFRAME;
		if (SendDlgItemMessage(hwndDlg, IDB_EX_NOPARENTNOTIFY, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newExStyle |= WS_EX_NOPARENTNOTIFY;
		if (SendDlgItemMessage(hwndDlg, IDB_EX_TOPMOST, BM_GETCHECK, 0, 0) == BST_CHECKED)
			SetWindowPos(hwndCap, HWND_TOPMOST, 0, 0, 0, 0, SWP_ASYNCWINDOWPOS | SWP_NOSIZE | SWP_NOMOVE);
		else SetWindowPos(hwndCap, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_ASYNCWINDOWPOS | SWP_NOSIZE | SWP_NOMOVE);
		newExStyle |= WS_EX_TOPMOST;
		if (SendDlgItemMessage(hwndDlg, IDB_EX_ACCEPTFILES, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newExStyle |= WS_EX_ACCEPTFILES;
		if (SendDlgItemMessage(hwndDlg, IDB_EX_TRANSPARENT, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newExStyle |= WS_EX_TRANSPARENT;
		if (SendDlgItemMessage(hwndDlg, IDB_EX_MDICHILD, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newExStyle |= WS_EX_MDICHILD;
		if (SendDlgItemMessage(hwndDlg, IDB_EX_TOOLWINDOW, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newExStyle |= WS_EX_TOOLWINDOW;
		if (SendDlgItemMessage(hwndDlg, IDB_EX_WINDOWEDGE, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newExStyle |= WS_EX_WINDOWEDGE;
		if (SendDlgItemMessage(hwndDlg, IDB_EX_CLIENTEDGE, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newExStyle |= WS_EX_CLIENTEDGE;
		if (SendDlgItemMessage(hwndDlg, IDB_EX_CONTEXTHELP, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newExStyle |= WS_EX_CONTEXTHELP;
		if (SendDlgItemMessage(hwndDlg, IDB_EX_RIGHT, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newExStyle |= WS_EX_RIGHT;
		if (SendDlgItemMessage(hwndDlg, IDB_EX_LEFT, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newExStyle |= WS_EX_LEFT;
		if (SendDlgItemMessage(hwndDlg, IDB_EX_RTLREADING, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newExStyle |= WS_EX_RTLREADING;
		if (SendDlgItemMessage(hwndDlg, IDB_EX_LTRREADING, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newExStyle |= WS_EX_LTRREADING;
		if (SendDlgItemMessage(hwndDlg, IDB_EX_LEFTSCROLLBAR, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newExStyle |= WS_EX_LEFTSCROLLBAR;
		if (SendDlgItemMessage(hwndDlg, IDB_EX_RIGHTSCROLLBAR, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newExStyle |= WS_EX_RIGHTSCROLLBAR;
		if (SendDlgItemMessage(hwndDlg, IDB_EX_CONTROLPARENT, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newExStyle |= WS_EX_CONTROLPARENT;
		if (SendDlgItemMessage(hwndDlg, IDB_EX_STATICEDGE, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newExStyle |= WS_EX_STATICEDGE;
		if (SendDlgItemMessage(hwndDlg, IDB_EX_APPWINDOW, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newExStyle |= WS_EX_APPWINDOW;
		if (SendDlgItemMessage(hwndDlg, IDB_EX_OVERLAPPEDWINDOW, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newExStyle |= WS_EX_OVERLAPPEDWINDOW;
		if (SendDlgItemMessage(hwndDlg, IDB_EX_PALETTEWINDOW, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newExStyle |= WS_EX_PALETTEWINDOW;
		if (SendDlgItemMessage(hwndDlg, IDB_EX_LAYERED, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newExStyle |= WS_EX_LAYERED;
		if (SendDlgItemMessage(hwndDlg, IDB_EX_NOINHERITLAYOUT, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newExStyle |= WS_EX_NOINHERITLAYOUT;
		if (SendDlgItemMessage(hwndDlg, IDB_EX_LAYOUTRTL, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newExStyle |= WS_EX_LAYOUTRTL;
		if (SendDlgItemMessage(hwndDlg, IDB_EX_COMPOSITED, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newExStyle |= WS_EX_COMPOSITED;
		if (SendDlgItemMessage(hwndDlg, IDB_EX_NOACTIVATE, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newExStyle |= WS_EX_NOACTIVATE;
		
		SetWindowLongPtr(hwndCap, GWL_EXSTYLE, newExStyle);
		SetWindowPos(hwndCap, NULL, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOZORDER | SWP_FRAMECHANGED);
		
		EndDialog(hwndDlg, IDOK);
		}
		break;
		case IDCANCEL:
		EndDialog(hwndDlg, IDCANCEL);
		break;
	}
	break;
	case WM_CLOSE:
	EndDialog(hwndDlg, 0);
	break;
	default:
	return false;
}
return true;
}

INT_PTR CALLBACK WinStyleDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
switch(uMsg) {
	case WM_INITDIALOG:
	{
	unsigned int style = GetWindowLong(hwndCap, GWL_STYLE);
	
	if ((style & WS_OVERLAPPED) == WS_OVERLAPPED)
		SendDlgItemMessage(hwndDlg, IDB_OVERLAPPED, BM_SETCHECK, BST_CHECKED, 0);
	if ((style & WS_POPUP) == WS_POPUP)
		SendDlgItemMessage(hwndDlg, IDB_POPUP, BM_SETCHECK, BST_CHECKED, 0);
	if ((style & WS_CHILD) == WS_CHILD)
		SendDlgItemMessage(hwndDlg, IDB_CHILD, BM_SETCHECK, BST_CHECKED, 0);
	if ((style & WS_MINIMIZE) == WS_MINIMIZE)
		SendDlgItemMessage(hwndDlg, IDB_MINIMIZESTY, BM_SETCHECK, BST_CHECKED, 0);
	if ((style & WS_VISIBLE) == WS_VISIBLE)
		SendDlgItemMessage(hwndDlg, IDB_VISIBLE, BM_SETCHECK, BST_CHECKED, 0);
	if ((style & WS_DISABLED) == WS_DISABLED)
		SendDlgItemMessage(hwndDlg, IDB_DISABLED, BM_SETCHECK, BST_CHECKED, 0);
	if ((style & WS_CLIPSIBLINGS) == WS_CLIPSIBLINGS)
		SendDlgItemMessage(hwndDlg, IDB_CLIPSIBLINGS, BM_SETCHECK, BST_CHECKED, 0);
	if ((style & WS_CLIPCHILDREN) == WS_CLIPCHILDREN)
		SendDlgItemMessage(hwndDlg, IDB_CLIPCHILDREN, BM_SETCHECK, BST_CHECKED, 0);
	if ((style & WS_MAXIMIZE) == WS_MAXIMIZE)
		SendDlgItemMessage(hwndDlg, IDB_MAXIMIZESTY, BM_SETCHECK, BST_CHECKED, 0);
	if ((style & WS_CAPTION) == WS_CAPTION)
		SendDlgItemMessage(hwndDlg, IDB_CAPTION, BM_SETCHECK, BST_CHECKED, 0);
	if ((style & WS_BORDER) == WS_BORDER)
		SendDlgItemMessage(hwndDlg, IDB_BORDER, BM_SETCHECK, BST_CHECKED, 0);
	if ((style & WS_DLGFRAME) == WS_DLGFRAME)
		SendDlgItemMessage(hwndDlg, IDB_DLGFRAME, BM_SETCHECK, BST_CHECKED, 0);
	if ((style & WS_VSCROLL) == WS_VSCROLL)
		SendDlgItemMessage(hwndDlg, IDB_VSCROLL, BM_SETCHECK, BST_CHECKED, 0);
	if ((style & WS_HSCROLL) == WS_HSCROLL)
		SendDlgItemMessage(hwndDlg, IDB_HSCROLL, BM_SETCHECK, BST_CHECKED, 0);
	if ((style & WS_SYSMENU) == WS_SYSMENU)
		SendDlgItemMessage(hwndDlg, IDB_SYSMENU, BM_SETCHECK, BST_CHECKED, 0);
	if ((style & WS_THICKFRAME) == WS_THICKFRAME)
		SendDlgItemMessage(hwndDlg, IDB_THICKFRAME, BM_SETCHECK, BST_CHECKED, 0);
	if ((style & WS_GROUP) == WS_GROUP)
		SendDlgItemMessage(hwndDlg, IDB_GROUP, BM_SETCHECK, BST_CHECKED, 0);
	if ((style & WS_TABSTOP) == WS_TABSTOP)
		SendDlgItemMessage(hwndDlg, IDB_TABSTOP, BM_SETCHECK, BST_CHECKED, 0);
	if ((style & WS_MINIMIZEBOX) == WS_MINIMIZEBOX)
		SendDlgItemMessage(hwndDlg, IDB_MINIMIZEBOX, BM_SETCHECK, BST_CHECKED, 0);
	if ((style & WS_MAXIMIZEBOX) == WS_MAXIMIZEBOX)
		SendDlgItemMessage(hwndDlg, IDB_MAXIMIZEBOX, BM_SETCHECK, BST_CHECKED, 0);
	if ((style & WS_TILED) == WS_TILED)
		SendDlgItemMessage(hwndDlg, IDB_TILED, BM_SETCHECK, BST_CHECKED, 0);
	if ((style & WS_ICONIC) == WS_ICONIC)
		SendDlgItemMessage(hwndDlg, IDB_ICONIC, BM_SETCHECK, BST_CHECKED, 0);
	if ((style & WS_SIZEBOX) == WS_SIZEBOX)
		SendDlgItemMessage(hwndDlg, IDB_SIZEBOX, BM_SETCHECK, BST_CHECKED, 0);
	if ((style & WS_TILEDWINDOW) == WS_TILEDWINDOW)
		SendDlgItemMessage(hwndDlg, IDB_TILEDWINDOW, BM_SETCHECK, BST_CHECKED, 0);
	if ((style & WS_OVERLAPPEDWINDOW) == WS_OVERLAPPEDWINDOW)
		SendDlgItemMessage(hwndDlg, IDB_OVERLAPPEDWINDOW, BM_SETCHECK, BST_CHECKED, 0);
	if ((style & WS_POPUPWINDOW) == WS_POPUPWINDOW)
		SendDlgItemMessage(hwndDlg, IDB_POPUPWINDOW, BM_SETCHECK, BST_CHECKED, 0);
	if ((style & WS_CHILDWINDOW) == WS_CHILDWINDOW)
		SendDlgItemMessage(hwndDlg, IDB_CHILDWINDOW, BM_SETCHECK, BST_CHECKED, 0);
	}
	break;
	case WM_COMMAND:
	switch(LOWORD(wParam)) {
		case IDOK:
		{
		unsigned int newStyle = 0;
		
		if (SendDlgItemMessage(hwndDlg, IDB_OVERLAPPED, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newStyle |= WS_OVERLAPPED;
		if (SendDlgItemMessage(hwndDlg, IDB_POPUP, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newStyle |= WS_POPUP;
		if (SendDlgItemMessage(hwndDlg, IDB_CHILD, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newStyle |= WS_CHILD;
		if (SendDlgItemMessage(hwndDlg, IDB_MINIMIZESTY, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newStyle |= WS_MINIMIZE;
		if (SendDlgItemMessage(hwndDlg, IDB_VISIBLE, BM_GETCHECK, 0, 0) == BST_CHECKED)
			ShowWindow(hwndCap, SW_SHOW);
		else ShowWindow(hwndCap, SW_HIDE);
		newStyle |= WS_VISIBLE;
		if (SendDlgItemMessage(hwndDlg, IDB_DISABLED, BM_GETCHECK, 0, 0) == BST_CHECKED)
			EnableWindow(hwndCap, false);
		else EnableWindow(hwndCap, true);
		if (SendDlgItemMessage(hwndDlg, IDB_CLIPSIBLINGS, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newStyle |= WS_CLIPSIBLINGS;
		if (SendDlgItemMessage(hwndDlg, IDB_CLIPCHILDREN, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newStyle |= WS_CLIPCHILDREN;
		if (SendDlgItemMessage(hwndDlg, IDB_MAXIMIZESTY, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newStyle |= WS_MAXIMIZE;
		if (SendDlgItemMessage(hwndDlg, IDB_CAPTION, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newStyle |= WS_CAPTION;
		if (SendDlgItemMessage(hwndDlg, IDB_BORDER, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newStyle |= WS_BORDER;
		if (SendDlgItemMessage(hwndDlg, IDB_DLGFRAME, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newStyle |= WS_DLGFRAME;
		if (SendDlgItemMessage(hwndDlg, IDB_VSCROLL, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newStyle |= WS_VSCROLL;
		if (SendDlgItemMessage(hwndDlg, IDB_HSCROLL, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newStyle |= WS_HSCROLL;
		if (SendDlgItemMessage(hwndDlg, IDB_SYSMENU, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newStyle |= WS_SYSMENU;
		if (SendDlgItemMessage(hwndDlg, IDB_THICKFRAME, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newStyle |= WS_THICKFRAME;
		if (SendDlgItemMessage(hwndDlg, IDB_GROUP, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newStyle |= WS_GROUP;
		if (SendDlgItemMessage(hwndDlg, IDB_TABSTOP, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newStyle |= WS_TABSTOP;
		if (SendDlgItemMessage(hwndDlg, IDB_MINIMIZEBOX, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newStyle |= WS_MINIMIZEBOX;
		if (SendDlgItemMessage(hwndDlg, IDB_MAXIMIZEBOX, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newStyle |= WS_MAXIMIZEBOX;
		if (SendDlgItemMessage(hwndDlg, IDB_TILED, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newStyle |= WS_TILED;
		if (SendDlgItemMessage(hwndDlg, IDB_ICONIC, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newStyle |= WS_ICONIC;
		if (SendDlgItemMessage(hwndDlg, IDB_SIZEBOX, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newStyle |= WS_SIZEBOX;
		if (SendDlgItemMessage(hwndDlg, IDB_TILEDWINDOW, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newStyle |= WS_TILEDWINDOW;
		if (SendDlgItemMessage(hwndDlg, IDB_OVERLAPPEDWINDOW, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newStyle |= WS_OVERLAPPEDWINDOW;
		if (SendDlgItemMessage(hwndDlg, IDB_POPUPWINDOW, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newStyle |= WS_POPUPWINDOW;
		if (SendDlgItemMessage(hwndDlg, IDB_CHILDWINDOW, BM_GETCHECK, 0, 0) == BST_CHECKED)
			newStyle |= WS_CHILDWINDOW;
		
		SetWindowLongPtr(hwndCap, GWL_STYLE, newStyle);
		SetWindowPos(hwndCap, NULL, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOZORDER | SWP_FRAMECHANGED | SWP_ASYNCWINDOWPOS);
		
		EndDialog(hwndDlg, IDOK);
		}
		break;
		case IDCANCEL:
		EndDialog(hwndDlg, IDCANCEL);
		break;
	}
	break;
	case WM_CLOSE:
	EndDialog(hwndDlg, 0);
	break;
	default:
	return false;
}
return true;
}

INT_PTR CALLBACK MiscelDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
switch(uMsg) {
	case WM_INITDIALOG:
	break;
	case WM_COMMAND:
	switch(LOWORD(wParam)) {
		case IDB_REVPASS:
		SetCapture(hwndDlg);
		break;
	}
	break;
	case WM_LBUTTONDOWN:
	{
		if (GetCapture() != hwndDlg) break;
		
		POINT pt;
		GetCursorPos(&pt);
		HWND wfp = WindowFromPoint(pt);
		
		if (wfp == NULL) break;
		if (!(GetWindowLong(wfp, GWL_STYLE) & ES_PASSWORD)) break;
		
		ReleaseCapture();
		
		PostMessage(wfp, EM_SETPASSWORDCHAR, (WPARAM)0, 0);
		
		SetForegroundWindow(GetParent(hwndDlg));
	}
	break;
	default:
	return false;
}
return true;
}

INT_PTR CALLBACK GlobalDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
static char keylog[105] = "";
static DWORD thrAttach;
static char prevchar;
static bool enabled = false;
switch(uMsg) {
	case WM_INITDIALOG:
	SetDlgItemText(hwndDlg, IDE_KEYLOG, keylog);
	
	if (enabled) {
	SendDlgItemMessage(hwndDlg, IDB_KEYENABLE, BM_SETCHECK, (WPARAM)BST_CHECKED, 0);
	EnableWindow(GetDlgItem(hwndDlg, IDE_KEYLOG), true);
	SetTimer(hwndDlg, ID_TIMER, 1, NULL);
	}
	break;
	case WM_COMMAND:
	switch(LOWORD(wParam)) {
		case IDB_KEYENABLE:
		switch(SendDlgItemMessage(hwndDlg, IDB_KEYENABLE, BM_GETCHECK, 0, 0)) {
			case BST_CHECKED:
			EnableWindow(GetDlgItem(hwndDlg, IDE_KEYLOG), true);
			enabled = true;
			
			SetTimer(hwndDlg, ID_TIMER, 1, NULL);
			break;
			case BST_UNCHECKED:
			EnableWindow(GetDlgItem(hwndDlg, IDE_KEYLOG), false);
			enabled = false;
			
			KillTimer(hwndDlg, ID_TIMER);
			break;
		}
		break;
		case IDB_CLEARKEY:
		ZeroMemory(keylog, 105);
		SetDlgItemText(hwndDlg, IDE_KEYLOG, keylog);
		break;
		case IDB_LOGOFF:
		ShutdownWindows(EWX_LOGOFF, hwndDlg);
		break;
		case IDB_RESTART:
		ShutdownWindows(EWX_REBOOT, hwndDlg);
		break;
		case IDB_SHUTDOWN:
		ShutdownWindows(EWX_POWEROFF, hwndDlg);
		break;
	}
	break;
	case WM_TIMER:
	switch (wParam) {
		case ID_TIMER:
		{
		AttachThreadInput(GetCurrentThreadId(), thrAttach, false);
		thrAttach = GetWindowThreadProcessId(GetFocus(), NULL);
		AttachThreadInput(GetCurrentThreadId(), thrAttach, true);
		
		BYTE keyState[256] = {0};
		WORD curKey;
		int i;
		int vk = 0;
		int sc;
		
		for (i=0x0D;i<=0xDF;i++) {
		if (i == 0x0E) i = 0x20;
		if (i == 0x21) i = 0x30;
		if (i == 0x3A) i = 0x41;
		if (i == 0x5B) i = 0x60;
		if (i == 0x70) i = 0xBA;
		if (i == 0xC1) i = 0xDB;
		if (GetAsyncKeyState(i) & 0x8000) vk = i;
		}
		
		if (!vk) {
		prevchar = 0;
		break;
		}
		
		if (GetAsyncKeyState(0x10) & 0x8000) keyState[0x10] = 0x80;
		
		sc = MapVirtualKey(vk, 0);
		ToAscii(vk, sc, keyState, &curKey, 0);
		if (prevchar == (char)curKey) break;
		prevchar = (char)curKey;
		
		size_t keyLen;
		StringCbLength(keylog, 101, &keyLen);
		
		if (keyLen == 100) {
		int i;
		for (i=0;i<99;i++) {
		keylog[i] = keylog[i + 1];
		}
		keyLen = 99;
		}
		
		keylog[keyLen] = prevchar;
		keylog[keyLen + 1] = '\0';
		
		SetDlgItemText(hwndDlg, IDE_KEYLOG, keylog);
		}
		break;
	}
	break;
	case WM_DESTROY:
	KillTimer(hwndDlg, ID_TIMER);
	break;
	default:
	return false;
}
return true;
}

INT_PTR CALLBACK ProcessDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
switch(uMsg) {
	case WM_INITDIALOG:
	{
	DWORD pId;
	GetWindowThreadProcessId(hwndCap, &pId);
	HANDLE hPro = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, false, pId);
	
	DWORD cbNeeded;
	EnumProcessModules(hPro, NULL, 0, &cbNeeded);
	DWORD numMods = cbNeeded / sizeof(HMODULE);
	HMODULE * modules = new HMODULE[numMods];
	EnumProcessModules(hPro, modules, numMods * sizeof(HMODULE), &cbNeeded);
	
	char * procPath = new char[MAX_PATH];
	GetModuleFileNameEx(hPro, modules[0], procPath, MAX_PATH);
	SetDlgItemText(hwndDlg, IDE_PROCPATH, procPath);
	
	char * modNames = new char[50 * numMods];
	ZeroMemory(modNames, 50 * numMods);
	char modName[50];
	
	int i;
	for (i=1;i<numMods;i++) {
		GetModuleBaseName(hPro, modules[i], modName, 50);
		if (i != numMods - 1) StringCbCat(modName, 50, ", ");
		StringCbCat(modNames, 50 * numMods, modName);
	}
	
	SetDlgItemText(hwndDlg, IDE_MODNAMES, modNames);
	
	ShowScrollBar(GetDlgItem(hwndDlg, IDE_MODNAMES), SB_VERT, true);
	
	CloseHandle(hPro);
	delete [] procPath;
	delete [] modules;
	delete [] modNames;
	}
	break;
	case WM_COMMAND:
	switch (LOWORD(wParam)) {
		case IDB_KILLPRO:
		{
			
		if (MessageBox(hwndDlg, "Forcefully terminating a process could cause system instability.\r\nAre you sure you want to continue?", "Warning", MB_ICONWARNING | MB_YESNO) != IDYES) break;
		
		DWORD pId;
		GetWindowThreadProcessId(hwndCap, &pId);
		
		HANDLE hPro = OpenProcess(PROCESS_TERMINATE, false, pId);
		if (hPro == NULL) break;
		
		TerminateProcess(hPro, 1);
		
		CloseHandle(hPro);
		}
		break;
		case IDB_KILLTHR:
		{
		if (MessageBox(hwndDlg, "Forcefully terminating a thread could cause system instability.\r\nAre you sure you want to continue?", "Warning", MB_ICONWARNING | MB_YESNO) != IDYES) break;
		
		DWORD tId = GetWindowThreadProcessId(hwndCap, NULL);
		
		HANDLE hThr = OpenThread(THREAD_TERMINATE, false, tId);
		if (hThr == NULL) break;
		
		TerminateThread(hThr, 1);
		
		CloseHandle(hThr);
		}
		break;
	}
	break;
	default:
	return false;
}
return true;
}

INT_PTR CALLBACK WindowDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
switch(uMsg) {
	case WM_INITDIALOG:
	break;
	case WM_COMMAND:
	switch(LOWORD(wParam)) {
		case IDB_SHOW:
		ShowWindowAsync(hwndCap, SW_SHOW);
		break;
		case IDB_HIDE:
		ShowWindowAsync(hwndCap, SW_HIDE);
		break;
		case IDB_MINIMIZE:
		ShowWindowAsync(hwndCap, SW_MINIMIZE);
		break;
		case IDB_MAXIMIZE:
		ShowWindowAsync(hwndCap, SW_MAXIMIZE);
		break;
		case IDB_RESTORE:
		ShowWindowAsync(hwndCap, SW_RESTORE);
		break;
		case IDB_CLOSE:
		PostMessage(hwndCap, WM_CLOSE, 0, 0);
		break;
		case IDB_MINIMIZEDI:
		ShowWindowAsync(hwndCap, SW_FORCEMINIMIZE);
		break;
		case IDB_DESTROY:
		EndTask(hwndCap, 0, 1);
		break;
		case IDB_WINSTY:
		DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_WINSTYLE), hwndDlg, WinStyleDlgProc);
		break;
		case IDB_EXWINSTY:
		DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_EXWINSTYLE), hwndDlg, ExWinStyleDlgProc);
		break;
		case IDB_CHOP:
		{
			HRGN hrgnWin = CreateRectRgn(0, 0, 0, 0);
			GetWindowRgn(hwndCap, hrgnWin);
			
			HRGN hrgnClip = CreateRectRgn(100, 100, 500, 500);
			
			HRGN hrgnWinNew = CreateRectRgn(0, 0, 0, 0);
			CombineRgn(hrgnWinNew, hrgnWin, hrgnClip, RGN_XOR);
			
			SetWindowRgn(hwndCap, hrgnWinNew, true);
			
			DeleteObject(hrgnWin);
			DeleteObject(hrgnClip);
			DeleteObject(hrgnWinNew);
		}
		break;
	}
	break;
	default:
	return false;
}
return true;
}

INT_PTR CALLBACK MainDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
static HWND currTab;
switch(uMsg) {
	case WM_INITDIALOG:
	{
		TCITEM tie;
		tie.mask = TCIF_TEXT;
		
		tie.pszText = "Window Tools";
		TabCtrl_InsertItem(GetDlgItem(hwndDlg, IDC_TABS), 0, &tie);
		
		tie.pszText = "Process/Thread Tools";
		TabCtrl_InsertItem(GetDlgItem(hwndDlg, IDC_TABS), 1, &tie);
		
		tie.pszText = "Global Tools";
		TabCtrl_InsertItem(GetDlgItem(hwndDlg, IDC_TABS), 2, &tie);
		
		tie.pszText = "Miscellaneous";
		TabCtrl_InsertItem(GetDlgItem(hwndDlg, IDC_TABS), 3, &tie);
	}
	break;
	case WM_NOTIFY:
	switch(((NMHDR*)lParam)->code) {
		case TCN_SELCHANGE:
		{
			int tab = TabCtrl_GetCurSel(GetDlgItem(hwndDlg, IDC_TABS));
			
			if (currTab != NULL) DestroyWindow(currTab);
			if (hwndCap != NULL || tab == 2 || tab == 3) currTab = SetCurrentTab(hwndDlg, tab);
		}
		break;
	}
	break;
	case WM_COMMAND:
	switch(LOWORD(wParam)) {
		case IDB_ACQUIRE:
		SetDlgItemText(hwndDlg, IDE_STATUS, "Acquiring....");
		SetCapture(hwndDlg);
		break;
		case IDB_ABOUT:
		DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_ABOUT), hwndDlg, AboutDlgProc);
		break;
		case IDB_EXIT:
		ShowWindowAsync(hwndCap, SW_SHOW);
		
		EndDialog(hwndDlg, 0);
		break;
	}
	break;
	case WM_LBUTTONDOWN:
	{
		if (GetCapture() != hwndDlg) break;
		
		POINT pt;
		GetCursorPos(&pt);
		HWND wfp = WindowFromPoint(pt);
		
		if (SendDlgItemMessage(hwndDlg, IDB_SAFE, BM_GETSTATE, 0, 0) == BST_CHECKED)
			wfp = GetAncestor(wfp, GA_ROOTOWNER);
		
		if (wfp == hwndDlg || wfp == NULL) break;
		
		ShowWindowAsync(hwndCap, SW_SHOW);
		
		hwndCap = wfp;
		
		ReleaseCapture();
		
		if (currTab != NULL) DestroyWindow(currTab);
		
		int tab = TabCtrl_GetCurSel(GetDlgItem(hwndDlg, IDC_TABS));
		currTab = SetCurrentTab(hwndDlg, tab);
		SetDlgItemText(hwndDlg, IDE_STATUS, "Acquired.");
	}
	break;
	case WM_CLOSE:
	ShowWindowAsync(hwndCap, SW_SHOW);
	
	EndDialog(hwndDlg, 0);
	break;
	default:
	return false;
}
return true;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow) {
INITCOMMONCONTROLSEX icc;
icc.dwSize = sizeof(INITCOMMONCONTROLSEX);
icc.dwICC = ICC_STANDARD_CLASSES | ICC_TAB_CLASSES | ICC_LISTVIEW_CLASSES;

InitCommonControlsEx(&icc);

DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_MAIN), NULL, MainDlgProc);

return 0;
}

HWND SetCurrentTab(HWND hwnd, int tab) {
HWND hTabChild;
switch (tab) {
	case 0:
	hTabChild = CreateDialog(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_WINDOW), hwnd, WindowDlgProc);
	SetWindowLong(hTabChild, GWL_ID, IDD_WINDOW);
	break;
	case 1:
	hTabChild = CreateDialog(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_PROCESS), hwnd, ProcessDlgProc);
	SetWindowLong(hTabChild, GWL_ID, IDD_PROCESS);
	break;
	case 2:
	hTabChild = CreateDialog(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_GLOBAL), hwnd, GlobalDlgProc);
	SetWindowLong(hTabChild, GWL_ID, IDD_GLOBAL);
	break;
	case 3:
	hTabChild = CreateDialog(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_MISCEL), hwnd, MiscelDlgProc);
	SetWindowLong(hTabChild, GWL_ID, IDD_MISCEL);
	break;
	default:
	hTabChild = NULL;
	break;
}
if (hTabChild != NULL) ShowWindow(hTabChild, SW_SHOW);
return hTabChild;
}

int ShutdownWindows(UINT type, HWND parentHwnd) {
char buffer[11];

if (type == EWX_LOGOFF) StringCbCopy(buffer, 11, "log out of");
else if (type == EWX_REBOOT) StringCbCopy(buffer, 11, "restart");
else if (type == EWX_POWEROFF) StringCbCopy(buffer, 11, "shutdown");
else return 0;

char buffer2[45];
StringCbPrintf(buffer2, 45, "Are you sure you want to %s Windows?", buffer);

if (MessageBox(parentHwnd, buffer2, "Alert", MB_ICONQUESTION | MB_YESNO) != IDYES) return 0;

OSVERSIONINFO ovi;
ovi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
GetVersionEx(&ovi);

if (ovi.dwPlatformId == VER_PLATFORM_WIN32_NT) {
HANDLE hToken;
TOKEN_PRIVILEGES tkp;

if (!OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken)) {
MessageBox(NULL, "Couldn't open process token!", "Error", MB_ICONEXCLAMATION | MB_OK);
return 0;
}

LookupPrivilegeValue(NULL, SE_SHUTDOWN_NAME, &tkp.Privileges[0].Luid);
 
tkp.PrivilegeCount = 1;
tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;

AdjustTokenPrivileges(hToken, false, &tkp, 0, (PTOKEN_PRIVILEGES)NULL, 0);
if (GetLastError() != ERROR_SUCCESS) {
MessageBox(NULL, "Couldn't adjust token privileges!", "Error", MB_ICONEXCLAMATION | MB_OK);
return 0;
}}
ExitWindowsEx(type, 0);
return 0;
}
